

let sample1 = [| 0 ; 6 ; 2 ; 1 ; 3 |]

let z = Z.of_int

let zget a x = z (a.(Z.to_int x))

let () =
  let t = Unix.gettimeofday () in
  let x = Lights.run_lights (z 10) (z 4) (zget sample1) in
  let t = Unix.gettimeofday () -. t in
  Format.printf "[%2.2f][should be 6] %s@." t (Z.to_string x)

let () = Random.init 2020

let sample2 _z =
  z (Random.int 1_000_001)

let () =
  let t = Unix.gettimeofday () in
  let x = Lights.run_lights (z 1_000_000) (z 100) sample2 in
  let t = Unix.gettimeofday () -. t in
  Format.printf "[%2.2f][should be 6823] %s@." t (Z.to_string x)

let () = Random.init 2020

let () =
  let t = Unix.gettimeofday () in
  let x = Lights.run_lights_fast (z 1_000_000) (z 100) sample2 in
  let t = Unix.gettimeofday () -. t in
  Format.printf "[%2.2f][should be 6823] %s@." t (Z.to_string x)
